## glibc 2.5.1-1eglibc27+0m5+cssu3

=== debian/changelog ===
glibc (2.5.1-1eglibc27+0m5+cssu3) unstable; urgency=low

  * Fix for CVE 2015-0235 (GHOST)

 -- Christian Ratzenhofer <christian.ratzenhofer@cdnm.at>  Sat, 28 Feb 2015 19:07:11 +0100

=== debian/control ===
Source: glibc
Section: libs
Priority: required
Build-Depends: gettext (>= 0.10.37-1), make (>= 3.80-1), dpkg-dev (>= 1.13.5), debianutils (>= 1.13.1), tar (>= 1.13.11), bzip2, texinfo (>= 4.0), linux-kernel-headers (>= 2.6.12) [!hurd-i386], mig (>= 1.3-2) [hurd-i386], hurd-dev (>= 20020608-1) [hurd-i386], gnumach-dev [hurd-i386], texi2html, file, gcc-4.2 [!powerpc !m68k !hppa !hurd-i386], autoconf, binutils (>= 2.16.1cvs20051109-1), sed (>= 4.0.5-4), gawk, debhelper (>= 4.1.76)
Build-Depends-Indep: perl, po-debconf
Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
Uploaders: Ben Collins <bcollins@debian.org>, GOTO Masanori <gotom@debian.org>, Philip Blundell <pb@nexus.co.uk>, Jeff Bailey <jbailey@raspberryginger.com>, Daniel Jacobowitz <dan@debian.org>, Clint Adams <schizo@debian.org>, Denis Barbier <barbier@debian.org>
Standards-Version: 3.6.2

Package: glibc-doc
Architecture: all
Section: doc
Priority: optional
Conflicts: libc-doc, libc6-doc, glibcdoc
Replaces: libc-doc, libc6-doc, glibcdoc
Provides: libc-doc
Description: GNU C Library: Documentation
 Contains The GNU C Library Reference manual in info and html format as
 well as man pages for libpthread functions. Also included is the complete
 GNU C Library ChangeLog.

Package: locales
Architecture: any
Section: libs
Priority: standard
Provides: i18ndata
Depends: ${locale:Depends}, debconf | debconf-2.0
Conflicts: localebin, wg15-locale, i18ndata, locale-ja, locale-ko, locale-vi, locale-zh, base-config
Replaces: localebin, wg15-locale, libc6-bin, i18ndata, glibc2, locale-ja, locale-ko, locale-vi, locale-zh, base-config
Description: GNU C Library: National Language (locale) data [support]
 Machine-readable data files, shared objects and programs used by the
 C library for localization (l10n) and internationalization (i18n) support.
 .
 This package contains the libc.mo i18n files, plus tools to generate
 locale definitions from source files (included in this package). It allows
 you to customize which definitions actually get generated. This is a
 savings over how this package used to be, where all locales were generated
 by default. This created a package that unpacked to an excess of 30 megs.

Package: nscd
Architecture: alpha amd64 arm armel armeb i386 m68k mips mipsel powerpc sparc ia64 hppa s390 sh3 sh4 sh3eb sh4eb freebsd-i386
Section: admin
Priority: optional
Depends: libc6 (>= ${Source-Version})
Replaces: libc6 (<< 2.1-4)
Description: GNU C Library: Name Service Cache Daemon
 A daemon which handles passwd, group and host lookups
 for running programs and caches the results for the next
 query. You should install this package only if you use
 slow Services like LDAP, NIS or NIS+

Package: libc6
Architecture: amd64 arm armel armeb i386 m68k mips mipsel powerpc sparc s390 hppa sh3 sh4 sh3eb sh4eb
Section: libs
Priority: required
Provides: ${locale:Depends}
Description: GNU C Library: Shared libraries and Timezone data
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 Timezone data is also included.

Package: libc6-dev
Architecture: amd64 arm armel armeb i386 m68k mips mipsel powerpc sparc s390 hppa sh3 sh4 sh3eb sh4eb
Section: libdevel
Priority: standard
Depends: libc6 (= ${Source-Version})
Recommends: gcc | c-compiler
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc6-dbg
Architecture: amd64 arm armel armeb i386 m68k mips mipsel powerpc sparc s390 hppa sh3 sh4 sh3eb sh4eb
Section: libdevel
Priority: extra
Provides: libc-dbg
Depends: libc6 (= ${Source-Version})
Description: GNU C Library: Libraries with debugging symbols
 Contains unstripped shared libraries.
 This package is provided primarily to provide a backtrace with
 names in a debugger, this makes it somewhat easier to interpret core
 dumps. The libraries are installed in /usr/lib/debug and can be
 used by placing that directory in LD_LIBRARY_PATH.
 Most people will not need this package.

Package: libc6-prof
Architecture: amd64 arm armel armeb i386 m68k mips mipsel powerpc sparc s390 hppa sh3 sh4 sh3eb sh4eb
Section: libdevel
Priority: extra
Depends: libc6 (= ${Source-Version})
Description: GNU C Library: Profiling Libraries
 Static libraries compiled with profiling info (-pg) suitable for use
 with gprof.

Package: libc6-pic
Architecture: amd64 arm armel armeb i386 m68k mips mipsel powerpc sparc s390 hppa sh3 sh4 sh3eb sh4eb
Section: libdevel
Priority: optional
Conflicts: libc-pic
Provides: libc-pic, glibc-pic
Depends: libc6 (= ${Source-Version})
Description: GNU C Library: PIC archive library
 Contains an archive library (ar file) composed of individual shared objects.
 This is used for creating a library which is a smaller subset of the
 standard libc shared library. The reduced library is used on the Debian
 boot floppies. If you are not making your own set of Debian boot floppies
 using the `boot-floppies' package, you probably don't need this package.

Package: libc6.1
Architecture: alpha ia64
Section: libs
Priority: required
Provides: ${locale:Depends}
Description: GNU C Library: Shared libraries and Timezone data
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 Timezone data is also included.

Package: libc6.1-dev
Architecture: alpha ia64
Section: libdevel
Priority: standard
Depends: libc6.1 (= ${Source-Version})
Recommends: gcc | c-compiler
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc6.1-dbg
Architecture: alpha ia64
Section: libdevel
Priority: extra
Provides: libc-dbg
Depends: libc6.1 (= ${Source-Version})
Description: GNU C Library: Libraries with debugging symbols
 Contains unstripped shared libraries.
 This package is provided primarily to provide a backtrace with
 names in a debugger, this makes it somewhat easier to interpret core
 dumps. The libraries are installed in /usr/lib/debug and can be
 used by placing that directory in LD_LIBRARY_PATH.
 Most people will not need this package.

Package: libc6.1-prof
Architecture: alpha ia64
Section: libdevel
Priority: extra
Depends: libc6.1 (= ${Source-Version})
Description: GNU C Library: Profiling Libraries
 Static libraries compiled with profiling info (-pg) suitable for use
 with gprof.

Package: libc6.1-pic
Architecture: alpha ia64
Section: libdevel
Priority: optional
Conflicts: libc-pic
Provides: libc-pic, glibc-pic
Depends: libc6.1 (= ${Source-Version})
Description: GNU C Library: PIC archive library
 Contains an archive library (ar file) composed of individual shared objects.
 This is used for creating a library which is a smaller subset of the
 standard libc shared library. The reduced library is used on the Debian
 boot floppies. If you are not making your own set of Debian boot floppies
 using the `boot-floppies' package, you probably don't need this package.

Package: libc0.3
Architecture: hurd-i386
Section: libs
Priority: required
Provides: ${locale:Depends}
Description: GNU C Library: Shared libraries and Timezone data
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 Timezone data is also included.

Package: libc0.3-dev
Architecture: hurd-i386
Section: libdevel
Priority: standard
Depends: libc0.3 (= ${Source-Version})
Recommends: gcc | c-compiler
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc0.3-dbg
Architecture: hurd-i386
Section: libdevel
Priority: extra
Provides: libc-dbg
Depends: libc0.3 (= ${Source-Version})
Description: GNU C Library: Libraries with debugging symbols
 Contains unstripped shared libraries.
 This package is provided primarily to provide a backtrace with
 names in a debugger, this makes it somewhat easier to interpret core
 dumps. The libraries are installed in /usr/lib/debug and can be
 used by placing that directory in LD_LIBRARY_PATH.
 Most people will not need this package.

Package: libc0.3-prof
Architecture: hurd-i386
Section: libdevel
Priority: extra
Depends: libc0.3 (= ${Source-Version})
Description: GNU C Library: Profiling Libraries
 Static libraries compiled with profiling info (-pg) suitable for use
 with gprof.

Package: libc0.3-pic
Architecture: hurd-i386
Section: libdevel
Priority: optional
Conflicts: libc-pic
Provides: libc-pic, glibc-pic
Depends: libc0.3 (= ${Source-Version})
Description: GNU C Library: PIC archive library
 Contains an archive library (ar file) composed of individual shared objects.
 This is used for creating a library which is a smaller subset of the
 standard libc shared library. The reduced library is used on the Debian
 boot floppies. If you are not making your own set of Debian boot floppies
 using the `boot-floppies' package, you probably don't need this package.

Package: libc1
Architecture: freebsd-i386
Section: libs
Priority: required
Provides: ${locale:Depends}
Description: GNU C Library: Shared libraries and Timezone data
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 Timezone data is also included.

Package: libc1-dev
Architecture: freebsd-i386
Section: libdevel
Priority: standard
Depends: libc1 (= ${Source-Version})
Recommends: gcc | c-compiler
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc1-dbg
Architecture: freebsd-i386
Section: libdevel
Priority: extra
Provides: libc-dbg
Depends: libc1 (= ${Source-Version})
Description: GNU C Library: Libraries with debugging symbols
 Contains unstripped shared libraries.
 This package is provided primarily to provide a backtrace with
 names in a debugger, this makes it somewhat easier to interpret core
 dumps. The libraries are installed in /usr/lib/debug and can be
 used by placing that directory in LD_LIBRARY_PATH.
 Most people will not need this package.

Package: libc1-prof
Architecture: freebsd-i386
Section: libdevel
Priority: extra
Depends: libc1 (= ${Source-Version})
Description: GNU C Library: Profiling Libraries
 Static libraries compiled with profiling info (-pg) suitable for use
 with gprof.

Package: libc1-pic
Architecture: freebsd-i386
Section: libdevel
Priority: optional
Conflicts: libc-pic
Provides: libc-pic, glibc-pic
Depends: libc1 (= ${Source-Version})
Description: GNU C Library: PIC archive library
 Contains an archive library (ar file) composed of individual shared objects.
 This is used for creating a library which is a smaller subset of the
 standard libc shared library. The reduced library is used on the Debian
 boot floppies. If you are not making your own set of Debian boot floppies
 using the `boot-floppies' package, you probably don't need this package.

Package: libc6-sparc64
Architecture: sparc
Section: libs
Priority: required
Depends: libc6 (= ${Source-Version})
Conflicts: gcc-3.0 (<< 1:3.0.4ds3-11), libgcc1 (<< 1:3.0.4ds3-11), fakeroot (<< 0.4.5-2.7)
Description: GNU C Library: 64bit Shared libraries for UltraSPARC
 This package includes shared versions of the standard C library and the
 standard math library, as well as many others. This is the 64bit version

## glibc 2.7

=== Makefile ===
# Copyright (C) 1996-2003, 2004, 2005, 2006 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

#
#	Sub-makefile for linuxthreads portion of the library.
#
subdir	:= linuxthreads

all: # Make this the default target; it will be defined in Rules.

linuxthreads-version := $(shell sed -n 's/^.*$(subdir)-\([0-9.]*\).*$$/\1/p' \
				    Banner)
libpthread-abi-frozen := GLIBC_2.3.2

headers := pthread.h semaphore.h
distribute := internals.h queue.h restart.h spinlock.h smp.h tst-signal.sh \
	      tst-cancel-wrappers.sh libc-tsd.c

routines := forward alloca_cutoff libc-cancellation libc_pthread_init
shared-only-routines = forward

extra-libs := libpthread
extra-libs-others := $(extra-libs)
install-lib-ldscripts := libpthread.so

libpthread-routines := attr cancel condvar join manager mutex ptfork \
		       ptlongjmp pthread pt-sigsuspend signals specific errno \
		       lockfile semaphore spinlock rwlock pt-machine \
		       oldsemaphore events getcpuclockid pspinlock barrier \
		       ptclock_gettime ptclock_settime sighandler \
		       pthandles libc-tls-loc pt-allocrtsig \
		       ptw-write ptw-read ptw-close ptw-fcntl ptw-accept \
		       ptw-connect ptw-recv ptw-recvfrom ptw-recvmsg \
		       ptw-send ptw-sendmsg ptw-sendto ptw-fsync ptw-lseek \
		       ptw-lseek64 ptw-llseek ptw-msync ptw-nanosleep \
		       ptw-open ptw-open64 ptw-pause ptw-pread ptw-pread64 \
		       ptw-pwrite ptw-pwrite64 ptw-tcdrain ptw-wait \
		       ptw-waitpid pt-system old_pthread_atfork pthread_atfork \
		       ptcleanup
#		       pthread_setuid pthread_seteuid pthread_setreuid \
#		       pthread_setresuid \
#		       pthread_setgid pthread_setegid pthread_setregid \
#		       pthread_setresgid

# Don't generate deps for calls with no sources.  See sysdeps/unix/Makefile.
omit-deps = $(unix-syscalls:%=ptw-%)

libpthread-shared-only-routines = pt-allocrtsig
libpthread-static-only-routines = pthread_atfork

linuxthreads-CPPFLAGS = -DIS_IN_linuxthreads=1

CFLAGS-pthread_atfork.c = -DNOT_IN_libc

nodelete-yes = -Wl,--enable-new-dtags,-z,nodelete
initfirst-yes = -Wl,--enable-new-dtags,-z,initfirst
LDFLAGS-pthread.so = $(nodelete-$(have-z-nodelete)) \
		     $(initfirst-$(have-z-initfirst))

vpath %.c Examples

tst-cancel-ARGS = "$(objpfx)"
CFLAGS-tst-cancel.c = -fno-inline -fno-inline-functions

include ../Makeconfig

ifeq ($(build-shared),yes)

# Set the `multidir' variable by grabbing the variable from the compiler.
# We do it once and save the result in a generated makefile.
-include $(objpfx)multidir.mk
$(objpfx)multidir.mk: $(common-objpfx)config.make
	$(make-target-directory)
	dir=`$(CC) $(CFLAGS) $(CPPFLAGS) -print-multi-directory`; \
	echo "multidir := $$dir" > $@T
	mv -f $@T $@
generated += multidir.mk

crti-objs := crti.o
crtn-objs := crtn.o
ifneq (,$(patsubst .,,$(multidir)))
generated-dirs := $(firstword $(subst /, , $(multidir)))
crti-objs += $(multidir)/crti.o
crtn-objs += $(multidir)/crtn.o
omit-deps += $(multidir)/crti $(multidir)/crtn
endif
extra-objs += $(crti-objs) $(crtn-objs)
omit-deps += crti crtn

CFLAGS-pt-initfini.s = -g0 -fPIC -fno-inline-functions $(fno-unit-at-a-time)
endif

librt-tests = ex10 ex11 tst-clock1
tests = ex1 ex2 ex3 ex4 ex5 ex6 ex7 ex8 ex9 $(librt-tests) ex12 ex13 joinrace \
	tststack $(tests-nodelete-$(have-z-nodelete)) ecmutex ex14 ex15 ex16 \
	ex17 ex18 tst-cancel tst-context bug-sleep \
	tst-cancel1 tst-cancel2 tst-cancel3 tst-cancel4 tst-cancel5 \
	tst-cancel6 tst-cancel7 tst-cancel8 tst-popen tst-popen2 tst-attr1 \
	tst-stack1 tst-align tst-tsd1 tst-sighandler1 tst-sighandler2
test-srcs = tst-signal
# These tests are linked with libc before libpthread
tests-reverse += tst-cancel5

ifeq ($(build-static),yes)
tests += tststatic tst-static-locale tst-cancel-static tst-stackguard1-static
tests-static += tststatic tst-static-locale tst-cancel-static \
	tst-stackguard1-static
endif

ifeq (yes,$(build-shared))
tests-nodelete-yes = unload
tests += tst-tls1 tst-_res1 tst-stackguard1
endif

modules-names = tst-_res1mod1 tst-_res1mod2 \
		tst-tls1mod tst-tls1moda tst-tls1modb tst-tls1modc \
		tst-tls1modd tst-tls1mode tst-tls1modf
extra-objs += $(addsuffix .os,$(strip $(modules-names)))
generated += $(addsuffix .so,$(strip $(modules-names)))
test-extras += $(modules-names)
test-modules = $(addprefix $(objpfx),$(addsuffix .so,$(modules-names)))

tst-tls1mod.so-no-z-defs = yes
tst-tls1moda.so-no-z-defs = yes
tst-tls1modb.so-no-z-defs = yes
tst-tls1modc.so-no-z-defs = yes
tst-tls1modd.so-no-z-defs = yes
tst-tls1mode.so-no-z-defs = yes
tst-tls1modf.so-no-z-defs = yes

ifeq ($(build-shared),yes)
# Build all the modules even when not actually running test programs.
tests: $(test-modules)
endif

# What we install as libpthread.so for programs to link against is in fact a
# link script.  It contains references for the various libraries we need.
# The libpthread.so object is not complete since some functions are only defined
# in libpthread_nonshared.a.
# We need to use absolute paths since otherwise local copies (if they exist)
# of the files are taken by the linker.
install: $(inst_libdir)/libpthread.so
$(inst_libdir)/libpthread.so: $(common-objpfx)format.lds \
			      $(objpfx)libpthread.so$(libpthread.so-version) \
			      $(inst_libdir)/$(patsubst %,$(libtype.oS),\
							$(libprefix)pthread) \
			      $(+force)
	(echo '/* GNU ld script';\
	 echo '   Use the shared library, but some functions are only in';\
	 echo '   the static library, so try that secondarily.  */';\
	 cat $<; \
	 echo 'GROUP ( $(slibdir)/libpthread.so$(libpthread.so-version)' \
	      '$(libdir)/$(patsubst %,$(libtype.oS),$(libprefix)pthread)'\
	      ')' \
	) > $@.new
	mv -f $@.new $@


extra-B-pthread.so = -B$(common-objpfx)linuxthreads/
$(objpfx)libpthread.so: $(addprefix $(objpfx),$(crti-objs) $(crtn-objs))
$(objpfx)libpthread.so: +preinit += $(addprefix $(objpfx),$(crti-objs))
$(objpfx)libpthread.so: +postinit += $(addprefix $(objpfx),$(crtn-objs))

znodelete-yes = -DHAVE_Z_NODELETE
CFLAGS-mutex.c += -D__NO_WEAK_PTHREAD_ALIASES
CFLAGS-specific.c += -D__NO_WEAK_PTHREAD_ALIASES
CFLAGS-pthread.c += -D__NO_WEAK_PTHREAD_ALIASES $(znodelete-$(have-z-nodelete))
CFLAGS-ptfork.c += -D__NO_WEAK_PTHREAD_ALIASES
CFLAGS-cancel.c += -D__NO_WEAK_PTHREAD_ALIASES -D_RPC_THREAD_SAFE_
CFLAGS-unload.c += -DPREFIX=\"$(objpfx)\"
CFLAGS-mutex.c += $(uses-callbacks)
CFLAGS-sighandler.c += $(uses-callbacks)

ifeq (yes,$(versioning))
-include $(common-objpfx)tls.make
libc-ok-for-link = $(use-thread)
else
libc-ok-for-link = yes
endif

ifeq (no,$(libc-ok-for-link))
# These hacks are necessary to let us link against a libc.so that exports
# the symbols _errno, _h_errno, and _res.  Those symbols are accessible
# in libc at runtime (dynamic linkable), but are not exported at link time
# so that applications cannot link against them.  However, libpthread.so
# needs to link against them for its __errno_location et al functions to
# find the locations that libc's symbols resolve to.  We cannot do this
# with aliases in libc.so(GLIBC_PRIVATE), because we need to refer to an
# executable's symbols when it defines them with copy relocs.
libc-link.so = $(objpfx)libc.so

$(objpfx)libc_pic_lite.a: $(common-objpfx)libc_pic.a
	cp $< $@T
	$(AR) d $@T errno.os herrno.os res_libc.os
	mv -f $@T $@

extra-objs += libc-tsd.os
$(objpfx)libc_pic_lite.os: $(objpfx)libc_pic_lite.a $(objpfx)libc-tsd.os
	$(LINK.o) -nostdlib -nostartfiles -r -o $@ \
		  $(LDFLAGS-c_pic.os) -Wl,-d -Wl,--whole-archive $^

# This trick leaves errno and h_errno undefined.
libc.so-no-z-defs = yes

$(objpfx)libc.so: $(elfobjdir)/soinit.os \
		  $(objpfx)libc_pic_lite.os \
		  $(elfobjdir)/sofini.os \
		  $(elfobjdir)/interp.os $(elfobjdir)/ld.so
	$(build-shlib)

generated += libc_pic_lite.a libc_pic_lite.os libc.so libc-tsd.os
else
libc-link.so = $(common-objpfx)libc.so
endif

include ../Rules

# Depend on libc.so so a DT_NEEDED is generated in the shared objects.
# This ensures they will load libc.so for needed symbols if loaded by
# a statically-linked program that hasn't already loaded it.
# Depend on ld.so too to get proper versions of ld.so symbols.
$(objpfx)libpthread.so: $(libc-link.so) $(common-objpfx)libc_nonshared.a \
			$(if $(filter yes,$(elf)), $(elfobjdir)/ld.so)

# Make sure we link with the thread library.
ifeq ($(build-shared),yes)
$(addprefix $(objpfx), \
  $(filter-out $(tests-static) $(tests-reverse) unload, \
    $(tests) $(test-srcs))): $(objpfx)libpthread.so \
			     $(objpfx)libpthread_nonshared.a
# $(objpfx)../libc.so is used instead of $(common-objpfx)libc.so,
# since otherwise libpthread.so comes before libc.so when linking.
$(addprefix $(objpfx), $(tests-reverse)): \
  $(objpfx)../libc.so $(objpfx)libpthread.so \
  $(objpfx)libpthread_nonshared.a
$(objpfx)../libc.so: $(common-objpfx)libc.so ;
$(addprefix $(objpfx),$(librt-tests)): $(common-objpfx)rt/librt.so
$(objpfx)unload: $(common-objpfx)dlfcn/libdl.so
$(objpfx)unload.out: $(objpfx)libpthread.so $(objpfx)libpthread_nonshared.a
else
$(addprefix $(objpfx),$(tests) $(test-srcs)): $(objpfx)libpthread.a
$(addprefix $(objpfx),$(librt-tests)): $(common-objpfx)rt/librt.a
endif
ifeq ($(build-bounded),yes)
$(tests:%=$(objpfx)%-bp): $(objpfx)libpthread_b.a
$(librt-tests:%=$(objpfx)%-bp): $(common-objpfx)rt/librt_b.a
endif

ifeq ($(build-static),yes)
$(addprefix $(objpfx), $(tests-static)): $(objpfx)libpthread.a
endif

ifeq ($(build-shared),yes)
vpath pt-initfini.c $(sysdirs)

$(objpfx)pt-initfini.s: pt-initfini.c
	$(compile.c) -S $(CFLAGS-pt-initfini.s) -finhibit-size-directive \
		$(patsubst -f%,-fno-%,$(exceptions)) -o $@

# We only have one kind of startup code files.  Static binaries and
# shared libraries are build using the PIC version.
$(objpfx)crti.S: $(objpfx)pt-initfini.s
	sed -n -e '1,/@HEADER_ENDS/p' \
	       -e '/@_.*_PROLOG_BEGINS/,/@_.*_PROLOG_ENDS/p' \
	       -e '/@TRAILER_BEGINS/,$$p' $< > $@
$(objpfx)crtn.S: $(objpfx)pt-initfini.s
	sed -n -e '1,/@HEADER_ENDS/p' \
	       -e '/@_.*_EPILOG_BEGINS/,/@_.*_EPILOG_ENDS/p' \
	       -e '/@TRAILER_BEGINS/,$$p' $< > $@

$(objpfx)defs.h: $(objpfx)pt-initfini.s
	sed -n -e '/@TESTS_BEGIN/,/@TESTS_END/p' $< | \
		$(AWK) -f ../csu/defs.awk > $@

$(objpfx)crti.o: $(objpfx)crti.S $(objpfx)defs.h
	$(compile.S) -g0 $(ASFLAGS-.os) -o $@

$(objpfx)crtn.o: $(objpfx)crtn.S $(objpfx)defs.h
	$(compile.S) -g0 $(ASFLAGS-.os) -o $@

ifneq ($(multidir),.)
$(objpfx)$(multidir):
	@mkdir -p $(objpfx)$(multidir)

$(objpfx)$(multidir)/crti.o: $(objpfx)crti.o $(objpfx)$(multidir)
	ln -f $< $@

$(objpfx)$(multidir)/crtn.o: $(objpfx)crtn.o $(objpfx)$(multidir)
	ln -f $< $@
endif

generated += crti.S crtn.S defs.h pt-initfini.s libpthread_nonshared.a
endif

ifeq (yes,$(build-static-nss))
otherlibs += $(nssobjdir)/libnss_files.a $(resolvobjdir)/libnss_dns.a \
             $(resolvobjdir)/libresolv.a
endif

ifeq (yes,$(build-shared))
$(objpfx)tst-_res1mod2.so: $(objpfx)tst-_res1mod1.so
$(objpfx)tst-_res1: $(objpfx)tst-_res1mod2.so $(shared-thread-library)

$(objpfx)tst-tls1: $(objpfx)tst-tls1mod.so $(shared-thread-library)

tests: $(objpfx)tst-tls2.out
$(objpfx)tst-tls2.out: tst-tls2.sh $(objpfx)tst-tls1 \
		       $(objpfx)tst-tls1moda.so $(objpfx)tst-tls1modb.so \

=== nptl/sysdeps/unix/sysv/linux/alpha/Makefile ===
# pull in __syscall_error routine, __sigprocmask, __syscall_rt_sigaction
libpthread-routines += ptw-sysdep ptw-sigprocmask ptw-rt_sigaction

## glibc 2.8~20080505

=== nscd/Makefile ===
# Copyright (C) 1998,2000,2002,2003,2004,2005,2006,2007,2008
#	Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

#
#	Sub-makefile for nscd portion of the library.
#
subdir	:= nscd

routines := nscd_getpw_r nscd_getgr_r nscd_gethst_r nscd_getai \
	    nscd_initgroups nscd_getserv_r
aux	:= nscd_helper

include ../Makeconfig

# To find xmalloc.c
vpath %.c ../locale/programs

nscd-modules := nscd connections pwdcache getpwnam_r getpwuid_r grpcache \
		getgrnam_r getgrgid_r hstcache gethstbyad_r gethstbynm3_r \
		getsrvbynm_r getsrvbypt_r servicescache \
		dbg_log nscd_conf nscd_stat cache mem nscd_setup_thread \
		xmalloc xstrdup aicache initgrcache gai res_hconf

ifeq ($(have-thread-library),yes)

ifneq (yesyes,$(have-fpie)$(build-shared))
others += nscd
endif
install-sbin := nscd

extra-objs := $(nscd-modules:=.o)

endif

ifeq (yes,$(build-static-nss))
otherlibs += $(nssobjdir)/libnss_files.a $(resolvobjdir)/libnss_dns.a \
	     $(resolvobjdir)/libresolv.a
endif

all-nscd-modules := $(nscd-modules) selinux
ifeq (yes,$(have-selinux))
ifeq (yes,$(have-libaudit))
libaudit = -laudit
ifeq (yes,$(have-libcap))
libcap = -lcap
endif
endif

nscd-modules += selinux
selinux-LIBS := -lselinux $(libaudit) $(libcap)

# The configure.in check for libselinux and its headers did not use
# $SYSINCLUDES.  The directory specified by --with-headers usually
# contains only the basic kernel interface headers, not something like
# libselinux.  So the simplest thing is to presume that the standard
# system headers will be ok for this file.
$(objpfx)nscd_stat.o: sysincludes = # nothing
$(objpfx)selinux.o: sysincludes = # nothing
endif

LDLIBS-nscd = $(selinux-LIBS)

distribute := nscd.h nscd-client.h dbg_log.h \
	      $(addsuffix .c, $(filter-out xmalloc,$(all-nscd-modules))) \
	      nscd.conf nscd.init nscd_proto.h nscd-types.h

include ../Rules

CFLAGS-nscd_getpw_r.c = -fexceptions
CFLAGS-nscd_getgr_r.c = -fexceptions
CFLAGS-nscd_gethst_r.c = -fexceptions
CFLAGS-nscd_getai.c = -fexceptions
CFLAGS-nscd_initgroups.c = -fexceptions

nscd-cflags = -DIS_IN_nscd=1 -D_FORTIFY_SOURCE=2
ifeq (yesyes,$(have-fpie)$(build-shared))
nscd-cflags += -fpie
endif
ifeq (yes,$(have-ssp))
nscd-cflags += -fstack-protector
endif

CFLAGS-nscd.c += $(nscd-cflags)
CFLAGS-connections.c += $(nscd-cflags)
CFLAGS-pwdcache.c += $(nscd-cflags)
CFLAGS-getpwnam_r.c += $(nscd-cflags)
CFLAGS-getpwuid_r.c += $(nscd-cflags)
CFLAGS-grpcache.c += $(nscd-cflags)
CFLAGS-getgrnam_r.c += $(nscd-cflags)
CFLAGS-getgrgid_r.c += $(nscd-cflags)
CFLAGS-hstcache.c += $(nscd-cflags)
CFLAGS-gethstbyad_r.c += $(nscd-cflags)
CFLAGS-gethstbynm3_r.c += $(nscd-cflags)
CFLAGS-dbg_log.c += $(nscd-cflags)
CFLAGS-nscd_conf.c += $(nscd-cflags)
CFLAGS-nscd_stat.c += $(nscd-cflags)
CFLAGS-cache.c += $(nscd-cflags)
CFLAGS-xmalloc.c += $(nscd-cflags)
CFLAGS-xstrdup.c += $(nscd-cflags)
CFLAGS-mem.c += $(nscd-cflags)
CFLAGS-nscd_setup_thread.c += $(nscd-cflags)
CFLAGS-aicache.c += $(nscd-cflags)
CFLAGS-selinux.c += $(nscd-cflags)
CFLAGS-initgrcache.c += $(nscd-cflags)
CFLAGS-gai.c += $(nscd-cflags)
CFLAGS-servicescache.c += $(nscd-cflags)
CFLAGS-getsrvbynm_r.c += $(nscd-cflags)
CFLAGS-getsrvbypt_r.c += $(nscd-cflags)
CFLAGS-res_hconf.c += $(nscd-cflags)

ifeq (yesyes,$(have-fpie)$(build-shared))
relro-LDFLAGS += -Wl,-z,now

$(objpfx)nscd: $(addprefix $(objpfx),$(nscd-modules:=.o))
	$(LINK.o) -pie -Wl,-O1 $(nscd-cflags) \
	  $(sysdep-LDFLAGS) $(config-LDFLAGS) $(relro-LDFLAGS) \
	  $(extra-B-$(@F:lib%.so=%).so) -B$(csu-objpfx) \
	  $(extra-B-$(@F:lib%.so=%).so) $(load-map-file) \
	  $(LDFLAGS) $(LDFLAGS-$(@F)) \
	  -L$(subst :, -L,$(rpath-link)) -Wl,-rpath-link=$(rpath-link) \
	  -o $@ $^ $(LDLIBS-nscd) $(common-objpfx)libc_nonshared.a
endif

# This makes sure -DNOT_IN_libc is passed for all these modules.
cpp-srcs-left := $(nscd-modules:=.c)
lib := nonlib
include $(patsubst %,$(..)cppflags-iterator.mk,$(cpp-srcs-left))

$(objpfx)nscd: $(nscd-modules:%=$(objpfx)%.o)

ifeq ($(build-shared),yes)
$(objpfx)nscd: $(common-objpfx)rt/librt.so $(shared-thread-library) \
	       $(common-objpfx)nis/libnsl.so
else
$(objpfx)nscd: $(common-objpfx)rt/librt.a $(static-thread-library) \
	       $(common-objpfx)nis/libnsl.a
endif
